Method: users.messages.batchModify

Modifies the labels and the Classification Label values on the specified messages. For administrators modifying messages for users in their organization, requests require authorization with a service account that has domain-wide delegation authority to impersonate users with the https://www.googleapis.com/auth/gmail.modify.restricted scope.

HTTP request

POST https://gmail.googleapis.com/gmail/v1/users/{userId}/messages/batchModify

The URL uses gRPC Transcoding syntax.

Path parameters

Parameters
userId

string

The user's email address. The special value me can be used to indicate the authenticated user.

Request body

The request body contains data with the following structure:

JSON representation
{
  "ids": [
    string
  ],
  "addLabelIds": [
    string
  ],
  "removeLabelIds": [
    string
  ],
  "addClassificationLabels": [
    {
      object (ClassificationLabelValue)
    }
  ],
  "removeClassificationLabelIds": [
    string
  ]
}
Fields
ids[]

string

The IDs of the messages to modify. There is a limit of 1000 ids per request.

addLabelIds[]

string

A list of label IDs to add to messages.

removeLabelIds[]

string

A list of label IDs to remove from messages.

addClassificationLabels[]

object (ClassificationLabelValue)

A list of Classification Label values to add. If a Classification Label with the same label ID is already applied to the message, fields with existing field IDs will be updated and fields with new field IDs will be added. There's a limit of 20 Classification Label values per request. If the message is already classified and the final total number of Classification Label values exceeds the maximum allowed number of Classification Label values per message, the modification fails.

removeClassificationLabelIds[]

string

A list of Classification Label values to remove from messages.

Response body

If successful, the response body is empty.

Authorization scopes

Requires one of the following OAuth scopes:

  • https://mail.google.com/
  • https://www.googleapis.com/auth/gmail.modify
  • https://www.googleapis.com/auth/gmail.modify.restricted

For more information, see the Authorization guide.